##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import gtk
from gtk import glade

import wid_int

class spinbutton(wid_int.wid_int):
	def __init__(self, parent, attrs={}):
		adj = gtk.Adjustment(0.0, -1000000000.0, 1000000000, 1.0, 5.0, 5.0)
		self.widget = gtk.SpinButton(adj, 1.0, digits=int( attrs.get('digits',(14,4))[1] ) )
		wid_int.wid_int.__init__(self, parent, attrs)
		self.widget.set_has_frame(False)
		self.widget.set_numeric(True)
		self.widget.connect('button_press_event', self._menu_open)
		if self.constraint['readonly']:
			self.widget.set_editable(False)
			self.widget.set_sensitive(False)
		self.state_set('valid')
		self.widget.connect('focus-in-event', lambda x,y: self._focus_in())
		self.widget.connect('focus-out-event', lambda x,y: self._focus_out())
		self.widget.connect('activate', self.sig_activate)


	def _value_get(self):
		try:
			return float(self.widget.get_text())
		except:
			return 0.0

	def validate(self):
		return True

	def _readonly_set(self, value):
		self.widget.set_editable(not value)
		self.widget.set_sensitive(not value)
		if value:
			self.color_set('normal')

	def _value_set(self, value):
		try:
			self.widget.set_value( float(value) )
		except:
			sexf.widget.set_text('')

#CHECKME: what's this for? At least, we should move this somewhere else...
	value = property(_value_get, _value_set, None,
	  'The content of the widget or ValueError if not valid')

	def clear(self):
		self.value = False

	def sig_activate(self, *args):
		if self.attrs.get('on_change',False):
			self.on_change(self.attrs['on_change'])
		
