##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields,osv
import ir

class model(osv.osv):
	_name = 'ir.model'
	_columns = {
		'name': fields.char('Name',size=64,translate=True),
		'model':  fields.char('model', size=64, required=True),
		'field_id': fields.one2many('ir.model.fields', 'model_id', 'field ids', required=True),
	}
	_defaults = {
		'name': lambda cr,uid,form: 'NoName',
	}
	def name_get(self, cr, user, ids, context={}):
		if not len(ids):
			return []
		
		res = []
		for r in self.read(cr, user, ids, ['model']):
			name = str(r['model'] or '')
			id = int(r['id'])
			res.append((id, name))
		return res 
model()


class ir_model_fields(osv.osv):
	_name = 'ir.model.fields'
	_columns = {
		'name': fields.char('Name',size=64),
		'model':  fields.char('Model Name', size=64, required=True),
		'relation':  fields.char('Model Relation', size=64),
		'model_id': fields.many2one('ir.model', 'Model id', required=True),
		'field_description': fields.char('Field Description', size=256),
		'ttype':fields.char('Field Type', size=64),
		'relate':fields.boolean('Client and Relate'),
	}
	_defaults = {
		'relate': lambda cr,uid,form: 1,
		'name': lambda cr,uid,form: 'NoName',
		'field_description': lambda cr,uid,form: 'No description available',
	}

	def name_get(self, cr, user, ids, context={}):
		if not len(ids):
			return []
		
		res = []
		for r in self.read(cr, user, ids, ['name']):
			name = str(r['name'] or '')
			id = int(r['id'])
			res.append((id, name))
		return res 
ir_model_fields()
