##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id: ir_ui_menu.py 1005 2005-07-25 08:41:42Z nicoe $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields,osv
from osv.orm import browse_null, browse_record

def one_in(setA, setB):
	"""Check the presence of an element of setA in setB
	"""
	for x in setA:
		if x in setB:
			return True
	return False

icons = [('STOCK_ABOUT','ABOUT'), ('STOCK_ADD','ADD'), ('STOCK_APPLY','APPLY'), ('STOCK_BOLD','BOLD'), ('STOCK_CANCEL','CANCEL'),
('STOCK_CDROM','CDROM'), ('STOCK_CLEAR','CLEAR'), ('STOCK_CLOSE','CLOSE'), ('STOCK_COLOR_PICKER','COLOR_PICKER'),
('STOCK_CONNECT','CONNECT'), ('STOCK_CONVERT','CONVERT'), ('STOCK_COPY','COPY'), ('STOCK_CUT','CUT'), ('STOCK_DELETE','DELETE'),
('STOCK_DIALOG_AUTHENTICATION','DIALOG_AUTHENTICATION'), ('STOCK_DIALOG_ERROR','DIALOG_ERROR'), ('STOCK_DIALOG_INFO','DIALOG_INFO'),
('STOCK_DIALOG_QUESTION','DIALOG_QUESTION'), ('STOCK_DIALOG_WARNING','DIALOG_WARNING'), ('STOCK_DIRECTORY','DIRECTORY'),
('STOCK_DISCONNECT','DISCONNECT'), ('STOCK_DND','DND'), ('STOCK_DND_MULTIPLE','DND_MULTIPLE'), ('STOCK_EDIT','EDIT'),
('STOCK_EXECUTE','EXECUTE'), ('STOCK_FILE','FILE'), ('STOCK_FIND','FIND'), ('STOCK_FIND_AND_REPLACE','FIND_AND_REPLACE'),
('STOCK_FLOPPY','FLOPPY'), ('STOCK_GOTO_BOTTOM','GOTO_BOTTOM'), ('STOCK_GOTO_FIRST','GOTO_FIRST'), ('STOCK_GOTO_LAST','GOTO_LAST'),
('STOCK_GOTO_TOP','GOTO_TOP'), ('STOCK_GO_BACK','GO_BACK'), ('STOCK_GO_DOWN','GO_DOWN'), ('STOCK_GO_FORWARD','GO_FORWARD'),
('STOCK_GO_UP','GO_UP'), ('STOCK_HARDDISK','HARDDISK'), ('STOCK_HELP','HELP'), ('STOCK_HOME','HOME'), ('STOCK_INDENT','INDENT'),
('STOCK_INDEX','INDEX'), ('STOCK_ITALIC','ITALIC'), ('STOCK_JUMP_TO','JUMP_TO'), ('STOCK_JUSTIFY_CENTER','JUSTIFY_CENTER'),
('STOCK_JUSTIFY_FILL','JUSTIFY_FILL'), ('STOCK_JUSTIFY_LEFT','JUSTIFY_LEFT'), ('STOCK_JUSTIFY_RIGHT','JUSTIFY_RIGHT'),
('STOCK_MEDIA_FORWARD','MEDIA_FORWARD'), ('STOCK_MEDIA_NEXT','MEDIA_NEXT'),
('STOCK_MEDIA_PAUSE','MEDIA_PAUSE'), ('STOCK_MEDIA_PLAY','MEDIA_PLAY'), ('STOCK_MEDIA_PREVIOUS','MEDIA_PREVIOUS'),
('STOCK_MEDIA_RECORD','MEDIA_RECORD'), ('STOCK_MEDIA_REWIND','MEDIA_REWIND'), ('STOCK_MEDIA_STOP','MEDIA_STOP'),
('STOCK_MISSING_IMAGE','MISSING_IMAGE'), ('STOCK_NETWORK','NETWORK'), ('STOCK_NEW','NEW'), ('STOCK_NO','NO'), ('STOCK_OK','OK'),
('STOCK_OPEN','OPEN'), ('STOCK_PASTE','PASTE'), ('STOCK_PREFERENCES','PREFERENCES'), ('STOCK_PRINT','PRINT'),
('STOCK_PRINT_PREVIEW','PRINT_PREVIEW'), ('STOCK_PROPERTIES','PROPERTIES'), ('STOCK_QUIT','QUIT'), ('STOCK_REDO','REDO'),
('STOCK_REFRESH','REFRESH'), ('STOCK_REMOVE','REMOVE'), ('STOCK_REVERT_TO_SAVED','REVERT_TO_SAVED'), ('STOCK_SAVE','SAVE'),
('STOCK_SAVE_AS','SAVE_AS'), ('STOCK_SELECT_COLOR','SELECT_COLOR'), ('STOCK_SELECT_FONT','SELECT_FONT'),
('STOCK_SORT_ASCENDING','SORT_ASCENDING'), ('STOCK_SORT_DESCENDING','SORT_DESCENDING'), ('STOCK_SPELL_CHECK','SPELL_CHECK'),
('STOCK_STOP','STOP'), ('STOCK_STRIKETHROUGH','STRIKETHROUGH'), ('STOCK_UNDELETE','UNDELETE'), ('STOCK_UNDERLINE','UNDERLINE'),
('STOCK_UNDO','UNDO'), ('STOCK_UNINDENT','UNINDENT'), ('STOCK_YES','YES'), ('STOCK_ZOOM_100','ZOOM_100'),
('STOCK_ZOOM_FIT','ZOOM_FIT'), ('STOCK_ZOOM_IN','ZOOM_IN'), ('STOCK_ZOOM_OUT','ZOOM_OUT')]


class ir_ui_menu(osv.osv):
	_name = 'ir.ui.menu'
	def _get_childs(self, cr, uid, ids, name, args, context):
		user_groups = self.pool.get('res.users').read(cr, uid, [uid])[0]['groups_id']
		res = {}
		for menu_id in ids:
			res[menu_id] = [x[0] for x in self.getAllChilds(cr, menu_id) 
				   if (one_in(x[1],user_groups) or not x[1])] 
		return res

	def getAllChilds(self, cr, parent_id):
		"""returns the list of childs (id, groupsID) of parent_id
		"""
		sql = """
		select id, gid
		from ir_ui_menu as m left join menu_group_rel as g on m.id=g.menu_id
		where parent_id = %s
		""" % parent_id
		cr.execute(sql)
		childs = {}
		for child in cr.dictfetchall():
			if child['id'] in childs:
				if child['gid']:
					childs[child['id']].append(child['gid'])
			else:
				if child['gid']:
					childs[child['id']] = [child['gid']]
				else:
					childs[child['id']] = []
		return childs.items()

	def _get_full_name(self, cr, uid, ids, name, args, context):
 		res = {}
		for m in self.browse(cr, uid, ids):
			res[m.id] = self._get_one_full_name(m)
		return res

	def _get_one_full_name(self, menu):
		if menu.parent_id:
			parent_path = self._get_one_full_name(menu.parent_id) + "/"
		else:
			parent_path = ''
		return parent_path + menu.name

	def unlink(*args):
		raise osv.except_osv('Application Error!', "You can not remove a menu !")

	_columns = {
		'name': fields.char('Menu', size=64, required=True, translate=True),
		'child_id': fields.function(_get_childs, method=True, string='Childs'),
		#Child_id2 is required for menu printing using custom report
		'child_id2' : fields.one2many('ir.ui.menu', 'parent_id','Child ids'),
		'parent_id': fields.many2one('ir.ui.menu', 'Parent Menu'),
		'groups_id': fields.many2many('res.groups', 'menu_group_rel', 'menu_id', 'gid', 'Groups'),
		'complete_name': fields.function(_get_full_name, method=True, string='Complete Name', type='char', size=64),
		'icon': fields.selection(icons, 'Icon', size=64)
	}
	_defaults = {
		'icon' : lambda x,y,z: 'STOCK_OPEN',
	}
ir_ui_menu()
