# -*- encoding: iso-8859-1 -*-
##############################################################################
#
# Copyright (c) 2005 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time

import netsvc
from osv import fields, osv, orm
import ir

#----------------------------------------------------------
# Dates
#----------------------------------------------------------
class huissier_dossier(osv.osv):
	_name = "huissier.dossier"
	_auto = True

	def _adjudication_get(self, cr, uid, ids, prop=None, unknow_none=None, unknow_dict={}):
		res = {}
		for id in ids:
			res[id]=0.0
			cr.execute("select sum(adj_price) from huissier_lots where dossier_id=%d", (id,))
			sum = cr.fetchone()
			if sum:
				res[id] = sum[0]
		return res
		
	def _costs_get(self, cr, uid, ids, prop=None, unknow_none=None,unknow_dict={}):
#FIXME	
		dossiers = self.browse(cr, uid, ids)
		res = {}
		for d in dossiers:
			costs = [l.amount_costs for l in d.lot_id]
			print costs
			cost_amount = reduce(lambda x, y: x+y, costs, 0.0)
			print cost_amount
			res[d.id] = cost_amount 
		return res

	def _total_get(self, cr, uid, ids, prop=None, unknow_none=None,unknow_dict={}):
		res = {}
		for id in ids:
			res[id] = self._adjudication_get(cr, uid, [id])[id] + self._costs_get(cr, uid, [id])[id]
		return res

	_columns = {
#		'name': fields.integer(u'Numro de vignette'),
		'num_vignette': fields.integer(u'Numro de vignette'),
		'etude_id': fields.many2one('res.partner', u'Etude', domain="[('category_id', '=', 'Etudes')]", required=True),

		'date_creation': fields.date(u'Cration'),

		'creancier': fields.many2one('res.partner', u'Crancier'),
#		'creancier_name': fields.char('Nom', size=64),
#		'creancier_address': fields.char('Adresse', size=128),
#		'creancier_zip': fields.char('Code postal', change_default=True, size=24),
#		'creancier_city': fields.char('Ville', size=64),

		'debiteur': fields.many2one('res.partner', u'Dbiteur'),
#		'debiteur_name': fields.char('Nom', size=64),
#		'debiteur_address': fields.char('Adresse', size=128),
#		'debiteur_zip': fields.char('Code postal', change_default=True, size=24),
#		'debiteur_city': fields.char('Ville', size=64),

#		'debiteur_naissance': fields.date('Date de naissance'),
#		'debiteur_tva':fields.char('TVA', size=32),
		
		'date_prevue': fields.date(u'Date prvue', required=True),
		'date_reelle': fields.date(u'Date relle', required=True),
		
		'mobilier_rentree': fields.date(u'Mobilier rentr le', required=True),
		'mobilier_retire': fields.date(u'Retir le'),
		
		'cubage' : fields.float(u'Cubage', digits=(12,2)),
		'langue': fields.selection((('fr',u'Franais'),('nl',u'Nerlandais')), u'Langue', required=True),
		
		'cost_id': fields.many2one('account.tax', u'Frais', required=True),
#		'info': fields.char('Description', size=64),
#		'lot_id': fields.one2many('huissier.lots', 'bord_vnd_id', 'Objects'),
#		'specific_cost_ids': fields.one2many('huissier.deposit.cost', 'deposit_id', 'Specific Costs'),

		'amount_adj': fields.function(_adjudication_get, method=True, string=u'Total Adjudication'),
		'amount_costs': fields.function(_costs_get, method=True, string=u'Total Adjudication'),
		'amount_total': fields.function(_total_get, method=True, string=u'Total Adjudication'),
		
		'state': fields.selection((('draft','Draft'),('closed','Closed')), u'tat', readonly=True),

		'lot_id': fields.one2many('huissier.lots', 'dossier_id', u'Objets'),
		'invoice_id': fields.many2one('account.invoice', u'Facture'),
		'income_account_id': fields.many2one('account.account', 'Compte Revenus', required=True),
#		'expense_account_id': fields.many2one('account.account', 'Expense Account', required=True),
	}
	_defaults = {
		'state': lambda uid, page, ref: 'draft',
		'date_creation': lambda x,y,z: time.strftime('%Y-%m-%d'),
	}

	def name_get(self, cr, uid, ids, context={}):
		if not len(ids):
			return []
		
		res = []
		for r in self.read(cr, uid, ids, ['num_vignette','etude']):
			name = str(r['num_vignette']) or '' + str(r['etude'][0]) or ''
			res.append((r['id'], name))
		return res

		
	def onchange_num_vignette(self, cr, uid, ids, num):
		cr.execute("select id,name from res_partner where id=(select etude_id from huissier_vignettes where %d >= first and %d <= last)", (num,num))
		res = cr.dictfetchall()
		if len(res)==0:
			return {}
		return {'value':{'etude_id':(res[0]['id'], res[0]['name'])}}

#	def close(self, cr, uid, ids, *args):
#		"""
#		Close a date.
#	
#		Create invoices for all buyers and sellers.
#	
#		facture pour 
#			garde meuble
#				voirie -> execption si pa
#			salle
#		pour 
#		
#		STATE = 'close'
#	
#		RETURN: True
#		"""
#		pass
		
	def close(self, cr, uid, ids, frais_voirie=False):
		"""
			Create an invoice for selected range of objects (ids)
		"""
		dt = time.strftime('%Y-%m-%d')
		print "voirie", frais_voirie
		dossiers = self.browse(cr, uid, ids)
		if not len(dossiers):
			return []
			
		frais_salle_str = {
			'fr': u'Frais de salle',
			'nl': u'Zaalkosten',
		}
		
		frais_voirie_str = {
			'fr': u'Frais de voirie',
#FIXME:
			'nl': u'Zaalkosten',
		}

		for dossier in dossiers:
			invoice_desc = u'Facture de salle'
			etude = dossier.etude_id
			lang = etude.lang or 'fr'
			print 'lang', lang

			account_receive_id = ir.ir_get(cr,uid,'meta','account.receivable',[('res.partner',etude.id)] )[0][2]
			lines = []
			
			line_desc = frais_salle_str[lang]
			if dossier.num_vignette:
				invoice_desc += ' (%d)' % dossier.num_vignette
				line_desc += ' (%d)' % dossier.num_vignette
			if dossier.debiteur:
				line_desc += ' %s' % dossier.debiteur.name
#CHECKME: fo des taxes pour les vignettes?
			lines.append((0,False, {'name':line_desc, 'quantity':1, 'account_id':dossier.income_account_id, 'price_unit':dossier.amount_costs}))

			if frais_voirie:
				line_desc = frais_voirie_str[lang]
				lines.append((0,False, {'name':line_desc, 'quantity':1, 'account_id':dossier.income_account_id, 'price_unit':frais_voirie}))
				
			addr = self.pool.get('res.partner').address_get(cr, uid, [etude.id], ['contact','invoice'])
			number = self.pool.get('ir.sequence').get(cr, uid, 'huissier.invoice.salle')

			new_invoice = {
				'name': invoice_desc,
				'number': number,
				'state': 'draft',
				'partner_id': etude.id,
				'address_contact_id': addr['contact'],
				'address_invoice_id': addr['invoice'],
				'partner_ref': etude.ref,
				'date_invoice': dt,
				'date_due': dt,
				'invoice_line': lines,
				'type': 'out_invoice',
				'account_id': account_receive_id,
			}

			invoice_id = self.pool.get('account.invoice').create(cr, uid, new_invoice)

#			number = self.pool.get('ir.sequence').get(cr, uid, 'huissier.invoice.salle')
#			cr.execute('UPDATE account_invoice SET number=%s WHERE id=%d', (number,invoice_id))
			
			wf_service = netsvc.LocalService("workflow")
			wf_service.trg_validate(uid, 'account.invoice', invoice_id, 'invoice_open', cr)

			self.write(cr, uid, [dossier.id], {'invoice_id':invoice_id, 'state':'closed'})
huissier_dossier()

#----------------------------------------------------------
# (Specific) Deposit Costs
#----------------------------------------------------------
#class huissier_deposit_cost(osv.osv):
#	_name = 'huissier.deposit.cost'
#	_auto = True
#	_columns = {
#		'name': fields.char('Cost Name', required=True, size=64),
#		'amount': fields.float('Amount'),
#		'account': fields.many2one('account.account', 'Destination Account', required=True),
#		'deposit_id': fields.many2one('huissier.deposit', 'Deposit'),
#	}
#huissier_deposit_cost()

#----------------------------------------------------------
# Lots
#----------------------------------------------------------

class huissier_lots(osv.osv):
	_name = "huissier.lots"
	_auto = True
	_order = "number"

	def _get_price_wh_costs(self, cr, uid, ids, name, arg, context):
		res = {}
		cr.execute("select id, dossier_id, adj_price from huissier_lots where id in ("+','.join([str(id) for id in ids])+")")
		for (id, dossier, price) in cr.fetchall():
#FIXME: there is a bug somewhere: the 0.0 from a spinint gets saved as a None value in the DB :(
			if not price:
				price = 0.0
			res[id] = price + self.get_costs_amount(cr, uid, ids, dossier, price)
		return res

	def _get_costs(self, cr, uid, ids, name, arg, context):
		res = {}
		cr.execute("select id, dossier_id, adj_price from huissier_lots where id in ("+','.join([str(id) for id in ids])+")")
		for (id, dossier, price) in cr.fetchall():
#FIXME: there is a bug somewhere: the 0.0 from a spinint gets saved as a None value in the DB :(
			if not price:
				price = 0.0
			res[id] = self.get_costs_amount(cr, uid, ids, dossier, price)
		return res

	_columns = {
		'dossier_id': fields.many2one('huissier.dossier', u'Dossier huissier'),
		'number': fields.integer(u'Lot', required=True, readonly=True),
		'name': fields.char(u'Description', size=256, required=True),
		'vat': fields.many2one('account.tax', u'Taxe', required=True),
		'adj_price': fields.float(u"Prix d'adjudication"),
		
		'buyer_ref': fields.many2one('res.partner', u'Rf. client', domain="[('category_id', '=', 'Clients habituels')]"),
#		'buyer_ref': fields.char(u'Rf. client', size=64),
		'buyer_name': fields.char(u'Nom et Prnom', size=64),
#		'buyer_firstname': fields.char(u'Prnom', size=64),
		'buyer_address': fields.char(u'Adresse', size=128),
		'buyer_zip': fields.char(u'Code postal', change_default=True, size=24),
		'buyer_city': fields.char(u'Ville', size=64),
		'buyer_birthdate': fields.char(u'Date de naissance', size=64),
		'buyer_vat': fields.char(u'TVA', size=64),
		'amount_costs': fields.function(_get_costs, method=True, string=u'Frais'),
		'price_wh_costs': fields.function(_get_price_wh_costs, method=True, string=u'A payer'),
	}
	_defaults = {
		'number': lambda obj,cr,uid: obj._get_next_lot_number(cr, uid)
	}
	
	def _get_next_lot_number(self, cr, uid):
		return int(self.pool.get('ir.sequence').get(cr, uid, 'huissier.lots'))
#		cr.execute('select max(number)+1 as number from huissier_lots')
#		res = cr.dictfetchall()
#		return res[0]['number'] or 1

	def get_costs_amount(self, cr, uid, ids, dossier_id, adj_price):
		dossier = self.pool.get('huissier.dossier').read(cr, uid, [dossier_id], ['cost_id'])[0]
		costs = self.pool.get('account.tax').compute(cr, uid, [dossier['cost_id'][0]], adj_price, 1)
		cost_amount = reduce(lambda x, y: x+y['amount'], costs, 0.0)
		return cost_amount
	
	def onchange_adj_price(self, cr, uid, ids, dossier_id, adj_price):
		print "onchange_adj_price", dossier_id, adj_price
		return {'value':{'price_wh_costs': adj_price + self.get_costs_amount(cr, uid, ids, dossier_id, adj_price)}}
		
	def onchange_buyer_ref(self, cr, uid, ids, buyer_id):
#		cr.execute('select id from res_partner where ref=%s', (buyer_ref,)) # and category = client
#		res = cr.dictfetchall()
#		if not len(res):
		if not buyer_id:
			return {
				'value': {'buyer_name':False, 'buyer_address':False, 'buyer_zip':False, 'buyer_city':False, 'buyer_birthdate':False, 'buyer_vat':False},
				'readonly': {'buyer_name':False, 'buyer_address':False, 'buyer_zip':False, 'buyer_city':False, 'buyer_birthdate':False, 'buyer_vat':False}
			}
		partner = self.pool.get('res.partner').browse(cr, uid, buyer_id)
		address = partner.address[0]
#TODO: birthdate
		return {
			'value': {'buyer_name': partner.name, 'buyer_address': address.street, 'buyer_zip':address.zip, 'buyer_city':address.city, 'buyer_birthdate':False, 'buyer_vat':partner.vat},
			'readonly': {'buyer_name':True, 'buyer_address':True, 'buyer_zip':True, 'buyer_city':True, 'buyer_birthdate':True, 'buyer_vat':True}
		}
		

huissier_lots()

class huissier_vignettes(osv.osv):
	_name = "huissier.vignettes"
	_auto = True
	_order = "first"
	_columns = {
		'etude_id': fields.many2one('res.partner', u'Etude', domain="[('category_id', '=', 'Etudes')]", required=True),
		'price': fields.float(u'Prix', required=True),
		'quantity': fields.integer(u'Quantit', required=True),
		'first': fields.integer(u'Rfrence de dpart', required=True),
		'last': fields.integer(u'Rfrence de fin', required=True),
		'acquis': fields.boolean(u'Pour acquis'),
		'cheque': fields.boolean(u'Reu cheque'),
		'invoice_id': fields.many2one('account.invoice', u'Facture'),
		'income_account_id': fields.many2one('account.account', 'Compte Revenus', required=True),
		'state': fields.selection( (('draft',u'draft'),('waiting',u'en attente'),('invoiced',u'factures')),u'tat', readonly=True),
	}
	_defaults = {
		'price': lambda obj,cr,uid: 11.0,
		'first': lambda obj,cr,uid: obj._get_next_first_number(cr, uid),
		'state': lambda obj,cr,uid: 'draft',
	}

	def _get_next_first_number(self, cr, uid):
		cr.execute('select max(last)+1 as number from huissier_vignettes')
		res = cr.dictfetchall()
		return res[0]['number'] or 1
		
	def onchange_quantity(self, cr, uid, ids, quantity, first):
		return {'value':{'last':first + quantity - 1}}
		
	def onchange_last(self, cr, uid, ids, first, last):
		if last < first:
			return {}
		else:
			return {'value':{'quantity':last - first + 1}}
			
	def invoice(self, cr, uid, ids):
		"""
			Create an invoice for selected range of 'vignettes' (ids)
		"""
		dt = time.strftime('%Y-%m-%d')

		label_ranges = self.browse(cr, uid, ids)
		if not len(label_ranges):
			return []
			
		# group label ranges by etude
		# ie create a dictionary containing lists of label ranges
		label_ranges_etude = {}
		for lr in label_ranges:
			if not lr.etude_id in label_ranges_etude:
				label_ranges_etude[lr.etude_id] = []
			label_ranges_etude[lr.etude_id].append(lr)
			
#FIXME: this is ugly!!!
#		invoice_comments = {
#			'fr': u'<para>Cher Matre,</para><para>Veuillez trouver ci-dessous le dcompte des montants dus  la salle de vente.</para>',
#			'nl': u'<para>Geachte Meester,</para><para>Gelieve hieronder de afrekening te willen vinden van de som verschuldigd aan de veilingzaal.</para>'
#		}
			
		line_descs = {
			'fr': u'vignette(s) (%d --> %d)',
			'nl': u'vignette(n) (%d --> %d)'
		}

		# use each list of label ranges in turn
		for label_ranges in label_ranges_etude.values():
			etude = label_ranges[0].etude_id

			label_quantity = reduce(lambda total, lr: total + lr['quantity'], label_ranges, 0.0)
			invoice_desc = u'Facture de vignettes (%d vignettes(s))' % (label_quantity,)

			lang = etude.lang or 'fr'
			print 'lang', lang
			
			account_receive_id = ir.ir_get(cr,uid,'meta','account.receivable',[('res.partner',etude.id)] )[0][2]

			lines = []
			for lr in label_ranges:
				line_desc = line_descs[lang] % (lr.first, lr.last)
#CHECKME: fo des taxes pour les vignettes?
				lines.append((0,False, {'name':line_desc, 'quantity':lr.quantity, 'account_id':lr.income_account_id, 'price_unit':lr.price}))

			addr = self.pool.get('res.partner').address_get(cr, uid, [etude.id], ['contact','invoice'])

			new_invoice = {
				'name': invoice_desc,
#				'comment': invoice_comments[lang],
				'state': 'draft',
				'partner_id': etude.id,
				'address_contact_id': addr['contact'],
				'address_invoice_id': addr['invoice'],
				'partner_ref': etude.ref,
				'date_invoice': dt,
				'date_due': dt,
				'invoice_line': lines,
				'type': 'out_invoice',
				'account_id': account_receive_id,
			}

			invoice_id = self.pool.get('account.invoice').create(cr, uid, new_invoice)

#			if action:
#				wf_service = netsvc.LocalService("workflow")
#				wf_service.trg_validate(uid, 'account.invoice', invoice_id, action, cr)

			for lr in label_ranges:
				print "id", lr.id
				
			lr_ids = [lr.id for lr in label_ranges]
			print "ids", lr_ids
			self.write(cr, uid, lr_ids, {'invoice_id':invoice_id, 'state':'waiting'})
			
	def open_invoices(self, cr, uid, ids):
		cr.execute("select id, invoice_id from huissier_vignettes where state='waiting'")
		vignettes = cr.dictfetchall()
	
		v_ids = [v['id'] for v in vignettes]
		inv_ids = [v['invoice_id'] for v in vignettes]
	
		# change the state of invoices to 'open' (using the workflow)
		wf_service = netsvc.LocalService("workflow")
		for id in inv_ids:
			# set the number manually
			number = self.pool.get('ir.sequence').get(cr, uid, 'huissier.invoice.vignettes')
			cr.execute('UPDATE account_invoice SET number=%s WHERE id=%d', (number,id))
			wf_service.trg_validate(uid, 'account.invoice', id, 'invoice_open', cr)
		
		# change the state of labels to 'invoiced'
		self.write(cr, uid, v_ids, {'state':'invoiced'})
		
		return inv_ids

huissier_vignettes()

