<?xml version="1.0" encoding="iso8859-1"?>

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="/">
		<xsl:apply-templates select="listing"/>
	</xsl:template>

	<xsl:template match="listing">
		<document xmlns:fo="http://www.w3.org/1999/XSL/Format">
			<template leftMargin="2.0cm" rightMargin="2.0cm" topMargin="2.0cm" bottomMargin="2.0cm" title="" author="Generated by Tiny ERP" pageSize="29.7cm,21cm">
				<pageTemplate id="all">
					<pageGraphics>
					</pageGraphics>
					<frame id="list" x1="1.0cm" y1="1.0cm" width="27.7cm" height="19cm"/>
				</pageTemplate>
			</template>

			<stylesheet>
				<paraStyle name="small" fontName="Courier" fontSize="12" spaceBefore="0mm" spaceAfter="0mm"/>
				<paraStyle name="verysmall" fontSize="10" fontName="Courier" spaceBefore="0mm" spaceAfter="0mm"/>
				<paraStyle name="smallest" fontSize="8" fontName="Courier" spaceBefore="-1mm" spaceAfter="-1Mm"/>

				<blockTableStyle id="palais">
					<blockValign value="TOP"/>
					<blockAlignment value="LEFT"/>
					<blockFont name="Helvetica-Bold" size="10"/>
					<blockTextColor colorName="black"/>
					<lineStyle kind="LINEABOVE" thickness="0.5" colorName="black" start="0,0" stop="-1,0"/>
					<lineStyle kind="LINEABOVE" thickness="0.5" colorName="black" start="0,0" stop="-1,0"/>
					<lineStyle kind="LINEBELOW" thickness="0.5" colorName="black"/>
					<lineStyle kind="LINEBEFORE" thickness="0.5" colorName="black" start="0,0" stop="-1,-1"/>
					<lineStyle kind="LINEBEFORE" thickness="0.5" colorName="black" start="0,0" stop="0,-1"/>
					<lineStyle kind="LINEAFTER" thickness="0.5" colorName="black" start="-1,0" stop="-1,-1"/>
					<blockBackground colorName="(1,1,1)" start="0,0" stop="-1,-1"/>
					<blockBackground colorName="(0.88,0.88,0.88)" start="0,0" stop="-1,0"/>
				</blockTableStyle>
			</stylesheet>

			<story>
				<para>Chers Confrres,</para>
				<para>Voici le relev des ventes sur saisies pour la priode du <xsl:value-of select="date1"/> au <xsl:value-of select="date2"/>.</para>
				<blockTable colWidths="4cm,3cm,2cm,1.5cm,4cm,3cm" style="palais">
					<xsl:apply-templates select="dossier"/>
				</blockTable>
			</story>
		</document>
	</xsl:template>
	
	<xsl:template match="dossier">
		<tr>
			<td><para><xsl:value-of select="name"/></para></td>
			<td><para><xsl:value-of select="address"/></para></td>
			<td><para>
				<xsl:choose>
					<xsl:when test="vat!=''">
						<xsl:value-of select="vat"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="birthdate"/>
					</xsl:otherwise>
				</xsl:choose>
			</para></td>
			<td><xsl:value-of select="adj"/></td>
			<td><para><xsl:value-of select="study"/></para></td>
			<td><para><xsl:value-of select="date"/></para></td>
		</tr>
	</xsl:template>
</xsl:stylesheet>
