# -*- coding: iso-8859-1 -*-
##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time

import wizard
import netsvc
import sql_db

invoice_form = '''<?xml version="1.0"?>
<form title="Paid ?">
	<field name="number"/>
</form>'''

invoice_fields = {
	'number': {'string':'Factures en attente', 'type':'integer', 'required':True, 'readonly':True},
}

def _get_value(self, uid, datas):
	cr = sql_db.db.cursor()
	cr.execute("select count(id) as number from huissier_vignettes where state='waiting'")
	res = cr.dictfetchall()
	cr.close()
	return {'number': res[0]['number'] or 0}

def _open_label_invoices(self, uid, datas):
	if datas['form']['number']==0:
		return {}
		
	# change the state of invoices to 'open' (using the workflow) and the state of labels to 'invoiced'
	service = netsvc.LocalService("object_proxy")
	inv_ids = service.execute(uid, 'huissier.vignettes', 'open_invoices', [])
	return {'ids':inv_ids}

class wizard_invoice_labels(wizard.interface):
	states = {
		'init': {
			'actions': [_get_value], 
			'result': {'type': 'form', 'arch':invoice_form, 'fields': invoice_fields, 'state':[('invoices','Imprimer les factures'), ('end','Annuler')]}
		},
		'invoices': {
			'actions': [_open_label_invoices],
			'result': {'type': 'print', 'report':'huissier.label.invoices', 'state':'end'}
		}
	}
wizard_invoice_labels('huissier.labels.invoice.open')


