# -*-encoding: iso8859-1 -*-
##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import sql_db
import ir
from osv.osv import osv_pools
from report.interface import report_rml
from report.int_to_text import int_to_text
import re
from  xml.dom import minidom

def toxml(val):
	val = val.replace('&', '&amp;').replace('<b>','&lt;b&gt;').replace('<i>','&lt;i&gt;').replace('<u>','&lt;u&gt;').replace('</b>','&lt;/b&gt;').replace('</i>','&lt;/i&gt;').replace('</u>','&lt;/u&gt;').encode('utf8')
	new_val = val
	for m in re.finditer('<font [^>]*>', val):
		tmp = val[m.start():m.end()].replace('<', '&lt;').replace('>','&gt;')
		new_val = re.sub(val[m.start():m.end()], tmp, new_val, 1)
	return new_val.replace('</font>', '&lt;/font&gt;')


class report_custom(report_rml):
	def __init__(self, name, table, tmpl, xsl):
		report_rml.__init__(self, name, table, tmpl, xsl)

	def create_xml(self, uid, ids, datas, context={}):
		cr = sql_db.db.cursor()

		def process_node(node, copy, dom, level=0):
			for child in node.childNodes:
				if child.nodeType != child.TEXT_NODE:
					new_node = None
					if child.hasAttribute('style') and child.getAttribute('style') == 'italic':
						new_node = dom.createElement('i')
					elif child.hasAttribute('underline') and child.getAttribute('underline') == 'single':
						new_node = dom.createElement('u')
					elif child.hasAttribute('foreground'):
						new_node = dom.createElement('font')
						new_node.setAttribute('color', child.getAttribute('foreground'))
					elif child.hasAttribute('font_desc'):
						new_node = dom.createElement('font')
						new_node.setAttribute('size', child.getAttribute('font_desc')[-2:])
					elif child.hasAttribute('weight'):
						new_node = dom.createElement('b')
					else:
						new_node =  dom.createElement('font')
						new_node.setAttribute('size','14')
						
					
					new_child = process_node(child, new_node, dom, level+1)
					copy.appendChild(new_child)
				else:
					new_child = child.cloneNode(True)
					copy.appendChild(new_child)
			return copy


		new_dom = minidom.parseString('<letter><paragraphes></paragraphes></letter>')
		for letter_id in ids:
			letter = osv_pools.get('letter.letter').browse(cr, uid, letter_id)[0]
			for para in letter.paragraph_ids:
				dom = minidom.parseString('<paragraphe>'+para.content+'</paragraphe>')
				new_para = new_dom.createElement('paragraphe')
				new_child = process_node( dom.childNodes[0], new_para, new_dom)
				new_dom.firstChild.firstChild.appendChild(new_child)
		file('/tmp/terp.xml','wb+').write(new_dom.toxml().encode('utf8'))
		return toxml(new_dom.toxml())

report_custom('report.letter.letter', 'letter.letter', '', 'addons/letter/report/letter.xsl')


