##############################################################################
#
# Copyright (c) 2005 TINY SPRL. (http://tiny.be) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

#
# Order Point Method:
#    - Order if the virtual stock of today is bellow the min of the defined order point
#

import wizard
import netsvc
import sql_db
import time
from mx import DateTime
from osv import osv

parameter_form = '''<?xml version="1.0"?>
<form title="Parameters" colspan="4">
	<separator string="Time (days)" colspan="4"/>
	<field name="po_lead"/>
	<field name="security_lead"/>
	<separator string="Control" colspan="4"/>
	<field name="user_id"/>
</form>'''

parameter_fields = {
	'po_lead': {'string':'PO Lead Time', 'type':'float', 'required':True},
	'security_lead': {'string':'Security Days', 'type':'float', 'required':True},
	'user_id': {'string':'Send Result To', 'type':'many2one', 'relation':'res.users'},
}

def _procure_confirm(self, uid, datas):
	cr = sql_db.db.cursor()
	wf_service = netsvc.LocalService("workflow")
	offset = 0
	ids = [1]
	while len(ids):
		cr.execute('select id from stock_warehouse_orderpoint offset %d', (offset,))
		ids = map(lambda x: x[0], cr.fetchall())
		for op in osv.osv_pools.get('stock.warehouse.orderpoint').browse(cr, uid, ids):
			# TODO: improve this test
			if op.procurement_id and op.procurement_id.purchase_id and (op.procurement_id.purchase_id.state in ('draft','confirmed')):
				break
			prods = osv.osv_pools.get('stock.location')._product_virtual_get(cr, uid, op.warehouse_id.lot_stock_id.id, [op.product_id.id])[op.product_id.id]
			if prods<op.product_min_qty:
				qty = op.product_max_qty-prods
				reste = qty % op.qty_multiple
				if reste>0:
					qty += op.qty_multiple-reste
				newdate = DateTime.now() + DateTime.RelativeDateTime(days=op.product_id.seller_delay)
				proc_id = osv.osv_pools.get('mrp.procurement').create(cr, uid, {
					'name': 'OP:'+str(op.id),
					'date_planned': newdate.strftime('%Y-%m-%d'),
					'product_id': op.product_id.id,
					'product_qty': qty,
					'product_uom': op.product_uom.id,
					'location_id': op.warehouse_id.lot_input_id.id,
					'procure_method': 'make_to_order',
					'origin': 'OP:'+str(op.id)+':'+op.name
				})
				wf_service = netsvc.LocalService("workflow")
				wf_service.trg_validate(uid, 'mrp.procurement', proc_id, 'button_confirm', cr)
				wf_service.trg_validate(uid, 'mrp.procurement', proc_id, 'button_check', cr)
				osv.osv_pools.get('stock.warehouse.orderpoint').write(cr, uid, [op.id], {'procurement_id':proc_id})
		offset+=len(ids)
		cr.commit()
	cr.close()
	return {}

def _get_value(self, uid, datas):
	return {}

class procurement_compute(wizard.interface):
	states = {
		'init': {
			'actions': [_get_value],
			'result': {'type': 'form', 'arch':parameter_form, 'fields': parameter_fields, 'state':[('compute','Compute Procurements'), ('end','Cancel')]}
		},
		'compute': {
			'actions': [_procure_confirm],
			'result': {'type': 'state', 'state':'end'}
		},
	}
procurement_compute('mrp.procurement.orderpoint.compute')


