##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import os, time
import ir, netsvc, sql_db
import osv
from interface import  report_rml
import re

parents = {
	'tr':1,
	'li':1,
	'story': 0
}


class rml_parse(object):
	def __init__(self):
		self.regex = re.compile('\[\[(.+?)\]\]')

	def _eval(self, expr):
		return eval(expr, {'o':self.objs[0]} )

	def _find_parent(self, node):
		while True:
			if not node.parentNode:
				return False
			node = node.parentNode
			if node.nodeType == node.ELEMENT_NODE and node.localName in parents:
				break
		return node

	def _parse_text(self, node, text, level=0):
		res = self.regex.findall(text)
		todo = []
		for key in res:
			newtext = self._eval(key)
			if type(newtext)==type([]):
				todo.append((key, newtext))
			else:
				if type(newtext) not in (type(''), type(u'')):
					newtext = str(newtext)
				text = text.replace('[['+key+']]', newtext)
		if len(todo):
			for key, newtext in todo:
				parent_node = self._find_parent(node)

				if parents.get(parent_node.localName,False):
					nodes = [parent_node]
				else:
					pass

				for i in range(len(todo[0][1]) - 1):
					newnode = parent_node.cloneNode(1)
					if parents.get(parent_node.localName,False):
						n = parent_node.parentNode
						parent_node.parentNode.insertBefore(newnode, parent_node)
						nodes.append(newnode)
					else:
						print 'PASS'
						pass

				for n in range(len(nodes)):
					self._modify_rec_node(nodes[n], n)
			return False
		return text

	def _modify_rec_node(self, node, level):
		for n in node.childNodes:
			if n.nodeType == n.ELEMENT_NODE:
				self._modify_rec_node(n, level)
			elif (n.nodeType == node.CDATA_SECTION_NODE) or (n.nodeType == node.TEXT_NODE):
				res = self.regex.findall(n.data)
				for key in res:
					newtext = self._eval(key)
					if type(newtext)==type([]):
						n.data = n.data.replace('[['+key+']]', '[['+key+'['+str(level)+'] ]]')
			else:
				print 'unknown node', n
		return True

	def _parse_node(self, node, level=0):
		for n in node.childNodes:
			if n.nodeType == n.ELEMENT_NODE:
				self._parse_node(n, level)
			elif (n.nodeType == node.CDATA_SECTION_NODE) or (n.nodeType == node.TEXT_NODE):
				txt = self._parse_text(n,n.data,level)
				if txt:
					n.data = txt

	def _parse(self, rml, objs):
		import xml.dom.minidom
		self.objs = objs
		self.dom = xml.dom.minidom.parseString(rml)
		el = self.dom.documentElement
#Ged> C'est normal qu'on parse deux fois la racine?		
		self._parse_node(el)
		self._parse_node(el)
		return el.toxml('utf-8')


class report_sxw(report_rml):
	def __init__(self, name, table, rml):
		report_rml.__init__(self, name, table, rml, '')
		self.bin_datas = {}

	def create(self, uid, ids, datas, context={}):
		rml = file(self.tmpl).read()

		cr = sql_db.db.cursor()
		objs = osv.osv.osv_pools.get(self.table).browse(cr, uid, ids)
		rml_parser = rml_parse()
		rml2 = rml_parser._parse(rml, objs)
		cr.close()

		create_doc = self.generators[datas.get('report_type','pdf')]
		pdf = create_doc(rml2)
		return pdf 

#report_custom('report.account.invoice', 'account.invoice', 'addons/account/report/invoice.rml', 'addons/account/report/partner_receivable.xsl')


